## wlmaker 0.7.1

=== CMakeLists.txt ===
# Copyright 2023 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Default arguments:
# cmake -DCMAKE_INSTALL_PREFIX:PATH=${HOME}/.local -Dconfig_DOXYGEN_CRITICAL=ON -Dconfig_WERROR=ON -DIWYU_MODE=FAIL -B build
# CC=clang cmake -DCMAKE_INSTALL_PREFIX:PATH="${HOME}/.local" -Dconfig_DOXYGEN_CRITICAL=ON -Dconfig_WERROR=ON -DIWYU_MODE=FAIL -B build-clang
#
# Useor "/etc".

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)
PROJECT(
  wlmaker
  VERSION "0.7.1"
  DESCRIPTION "Wayland Maker - A Wayland compositor inspired by Window Maker"
  HOMEPAGE_URL "https://github.com/phkaeser/wlmaker"
  LANGUAGES C)

# Requires out-of-source builds.
FILE(TO_CMAKE_PATH "${PROJECT_BINARY_DIR}/CMakeLists.txt" LOCATION_PATH)
IF(EXISTS "${LOCATION_PATH}")
  MESSAGE(
    FATAL_ERROR
    "You cannot build into a source directory (containing a CMakeLists.txt file).\n"
    "Please make a build subdirectory, for example:\n"
    "cmake -B build\n"
    "(cd build && make)")
ENDIF()

SET(WLMAKER_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
SET(WLMAKER_VERSION_MINOR ${PROJECT_VERSION_MINOR})
SET(WLMAKER_VERSION_FULL ${PROJECT_VERSION})
# PROJECT version check: When on a git repository, we verify that the PROJECT
# version is equal-or-larger than the git version.
IF(EXISTS "${CMAKE_SOURCE_DIR}/.git")
  EXECUTE_PROCESS(
    COMMAND ${CMAKE_COMMAND} -E chdir "${CMAKE_SOURCE_DIR}"
    git describe --always --tags --dirty
    OUTPUT_VARIABLE git_version
    OUTPUT_STRIP_TRAILING_WHITESPACE
    RESULT_VARIABLE git_result)

  IF(git_result EQUAL 0)
    STRING(REGEX MATCH "^v([0-9]+)\\.([0-9]+)" DUMMY_VAR ${git_version})
    IF(NOT CMAKE_MATCH_COUNT EQUAL 2)
      MESSAGE(FATAL_ERROR "Not a v<MAJOR>.<MINOR> version \"${git_version}\"")
    ENDIF()

    IF(${PROJECT_VERSION_MAJOR} LESS ${CMAKE_MATCH_1} OR
        ${PROJECT_VERSION_MINOR} LESS ${CMAKE_MATCH_2})
      MESSAGE(FATAL_ERROR "Git ${CMAKE_MATCH_1}.${CMAKE_MATCH_2} >= "
        "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
    ENDIF()

    SET(WLMAKER_VERSION_MAJOR ${CMAKE_MATCH_1})
    SET(WLMAKER_VERSION_MINOR ${CMAKE_MATCH_2})
    SET(WLMAKER_VERSION_FULL ${git_version})
  ENDIF()
ENDIF()

# Defaults to /usr/local/lib for installation.
INCLUDE(GNUInstallDirs)
IF(CMAKE_INSTALL_PREFIX STREQUAL "/usr")
  # For targets /usr, forces configurations into XDG config default path.
  SET(WLMAKER_INSTALL_CONFIG_DIR "/etc/xdg/wlmaker")
ELSE()
  SET(WLMAKER_INSTALL_CONFIG_DIR "${CMAKE_INSTALL_SYSCONFDIR}/xdg/wlmaker")
ENDIF()

INCLUDE(CTest)

FIND_PACKAGE(PkgConfig REQUIRED)

PKG_CHECK_MODULES(CAIRO REQUIRED IMPORTED_TARGET cairo>=1.16.0)
PKG_CHECK_MODULES(XKBCOMMON REQUIRED IMPORTED_TARGET xkbcommon>=1.5.0)
PKG_CHECK_MODULES(LIBXDGBASEDIR REQUIRED IMPORTED_TARGET libxdg-basedir>=1.2)

# https://github.com/ianlancetaylor/libbacktrace.
# The REQUIRED arg is available only from cmake 3.28.
FIND_LIBRARY(LIBBACKTRACE backtrace)
IF(LIBBACKTRACE)
  MESSAGE(STATUS "Found libbacktrace: ${LIBBACKTRACE}")
ELSE()
  MESSAGE(STATUS "libbacktrace not found. Will compile without.")
ENDIF()

# Configuration. Remove CMakeCache.txt to rerun...
OPTION(config_DEBUG "Include debugging information" ON)
OPTION(config_OPTIM "Optimizations" OFF)
OPTION(config_DOXYGEN_CRITICAL "Whether to fail on doxygen warnings" OFF)
OPTION(config_WERROR "Make all compiler warnings into errors." OFF)

SET(IWYU_MODE "OFF" CACHE STRING "Whether to run `iwyu`. OFF, WARN or FAIL.")
SET_PROPERTY(CACHE IWYU_MODE PROPERTY STRINGS "OFF" "WARN" "FAIL")

# Toplevel compile options, for GCC and clang.
IF(CMAKE_C_COMPILER_ID MATCHES "Clang|GNU")
  ADD_COMPILE_OPTIONS(-Wall -Wextra)
  IF(config_WERROR)
    ADD_COMPILE_OPTIONS(-Werror)
  ENDIF(config_WERROR)

  IF(config_DEBUG)
    ADD_COMPILE_OPTIONS(-ggdb -DDEBUG)
  ENDIF(config_DEBUG)

  IF(config_OPTIM)
    ADD_COMPILE_OPTIONS(-O2)
  ELSE (config_OPTIM)
    ADD_COMPILE_OPTIONS(-O0)
  ENDIF(config_OPTIM)

  # CMake provides absolute paths to GCC, hence the __FILE__ macro includes the
  # full path. This option resets it to a path relative to project source.
  ADD_COMPILE_OPTIONS(-fmacro-prefix-map=${PROJECT_SOURCE_DIR}=.)

  # Run iwyu when available.
  IF((IWYU_MODE STREQUAL "WARN") OR (IWYU_MODE STREQUAL "FAIL"))
    FIND_PROGRAM(iwyu_executable NAMES include-what-you-use iwyu REQUIRED)

    IF(IWYU_MODE STREQUAL "FAIL")
      SET(iwyu_error "1")
    ELSE(IWYU_MODE STREQUAL "FAIL")
      SET(iwyu_error "0")
    ENDIF(IWYU_MODE STREQUAL "FAIL")

    IF(iwyu_executable)
      SET(iwyu_path_and_options
        ${iwyu_executable}
        -Xiwyu --error=${iwyu_error} -Xiwyu --transitive_includes_only -Xiwyu --mapping_file=${PROJECT_SOURCE_DIR}/iwyu-mappings.imp)
    ENDIF(iwyu_executable)

    MESSAGE(STATUS "Configured iwyu (${iwyu_executable}) to run in mode \"${IWYU_MODE}\"")
  ELSEIF(IWYU_MODE STREQUAL "OFF")
    # Permitted value, we don't set iwyu_path_and_options.
  ELSE()
    MESSAGE(FATAL_ERROR
      "Invalid value for IWYU_MODE: \"${IWYU_MODE}\". Must be OFF, WARN or FAIL")
  ENDIF()

ENDIF(CMAKE_C_COMPILER_ID MATCHES "Clang|GNU")
SET(CMAKE_C_STANDARD 11)

LIST(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

ADD_SUBDIRECTORY(apps)
ADD_SUBDIRECTORY(etc)
ADD_SUBDIRECTORY(protocols)
ADD_SUBDIRECTORY(third_party/protocols)
ADD_SUBDIRECTORY(share)
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(tests)
ADD_SUBDIRECTORY(tool)

ADD_SUBDIRECTORY(doc)

# Adds submodules last, to permit checking on already-existing targets.
ADD_SUBDIRECTORY(submodules)

=== apps/CMakeLists.txt ===
# Copyright 2023 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)

ADD_SUBDIRECTORY(libwlclient)
ADD_SUBDIRECTORY(primitives)

ADD_LIBRARY(wlm_graph_shared STATIC wlm_graph_shared.c)
TARGET_INCLUDE_DIRECTORIES(wlm_graph_shared PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
TARGET_LINK_LIBRARIES(wlm_graph_shared libwlclient primitives)

ADD_EXECUTABLE(example_toplevel example_toplevel.c)
TARGET_INCLUDE_DIRECTORIES(example_toplevel PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
TARGET_LINK_LIBRARIES(example_toplevel m libwlclient)

ADD_EXECUTABLE(wlmclock wlmclock.c)
TARGET_INCLUDE_DIRECTORIES(wlmclock PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
TARGET_LINK_LIBRARIES(wlmclock libwlclient primitives m)

ADD_EXECUTABLE(wlmeyes wlmeyes.c)
TARGET_INCLUDE_DIRECTORIES(wlmeyes PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
TARGET_LINK_LIBRARIES(wlmeyes m libwlclient)

ADD_EXECUTABLE(wlmcpugraph wlmcpugraph.c)
TARGET_INCLUDE_DIRECTORIES(wlmcpugraph PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
TARGET_LINK_LIBRARIES(wlmcpugraph wlm_graph_shared libwlclient primitives)

ADD_EXECUTABLE(wlmmemgraph wlmmemgraph.c)
TARGET_INCLUDE_DIRECTORIES(wlmmemgraph PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
TARGET_LINK_LIBRARIES(wlmmemgraph wlm_graph_shared libwlclient primitives)

ADD_EXECUTABLE(wlmnetgraph wlmnetgraph.c)
TARGET_INCLUDE_DIRECTORIES(wlmnetgraph PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
TARGET_LINK_LIBRARIES(wlmnetgraph wlm_graph_shared libwlclient primitives)

INSTALL(
  TARGETS wlmclock wlmeyes wlmcpugraph wlmmemgraph wlmnetgraph
  DESTINATION ${CMAKE_INSTALL_BINDIR})

IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    wlm_graph_shared PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
  SET_TARGET_PROPERTIES(
    example_toplevel PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
  SET_TARGET_PROPERTIES(
    wlmclock PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
  SET_TARGET_PROPERTIES(
    wlmeyes PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
  SET_TARGET_PROPERTIES(
    wlmcpugraph PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
  SET_TARGET_PROPERTIES(
    wlmmemgraph PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
  SET_TARGET_PROPERTIES(
    wlmnetgraph PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

=== dependencies/CMakeLists.txt ===
# Copyright 2023 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Default arguments:
# cmake -DCMAKE_INSTALL_PREFIX:PATH=${HOME}/.local -B build

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)
PROJECT(wlmaker VERSION 0.1
  DESCRIPTION "Wayland Maker - Dependencies"
  LANGUAGES C)

# TODO(kaeser@gubbe.ch): Add a target for refreshing all submodules.
# See https://cliutils.gitlab.io/modern-cmake/chapters/projects/submodule.html

# If not found: Try 'pip3 install --user meson'
FIND_PROGRAM(MESON_EXECUTABLE NAMES meson REQUIRED)
FIND_PROGRAM(NINJA_EXECUTABLE NAMES ninja REQUIRED)
FIND_PACKAGE(PkgConfig REQUIRED)

# https://github.com/phkaeser/libbase
# Initialize: git submodule update --init --recursive --merge
# Checkout: git submodule update --checkout --recursive --merge
# Update: git submodule update --remote --merge
# Update: (cd libbase && git pull)
# ADD_SUBDIRECTORY(libbase)

# wlroots -- build and configure from the git submodule.
# Note: This will *NOT* automatically install the library.
INCLUDE(ExternalProject)

ExternalProject_Add(dep-libbacktrace
  SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/libbacktrace"
  INSTALL_DIR ${CMAKE_INSTALL_PREFIX}
  CONFIGURE_COMMAND <SOURCE_DIR>/configure --prefix=<INSTALL_DIR> --datadir=<INSTALL_DIR>/share --datarootdir=<INSTALL_DIR>/share
  BUILD_COMMAND make
  INSTALL_COMMAND make install
)

# Wayland
# Packages needed: xsltproc xmlto
ExternalProject_Add(wayland
  SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/wayland"
  INSTALL_DIR ${CMAKE_INSTALL_PREFIX}
  CONFIGURE_COMMAND ${MESON_EXECUTABLE} --prefix=<INSTALL_DIR> <BINARY_DIR> <SOURCE_DIR> -Ddocumentation=false
  BUILD_COMMAND ${NINJA_EXECUTABLE} -C <BINARY_DIR>
  INSTALL_COMMAND ${NINJA_EXECUTABLE} -C <BINARY_DIR> install
)

# libdrm - libdrm-2.4.129
ExternalProject_Add(libdrm
  SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/libdrm"
  INSTALL_DIR ${CMAKE_INSTALL_PREFIX}
  CONFIGURE_COMMAND ${MESON_EXECUTABLE} --prefix=<INSTALL_DIR> <BINARY_DIR> <SOURCE_DIR>
  BUILD_COMMAND ${NINJA_EXECUTABLE} -C <BINARY_DIR>
  INSTALL_COMMAND ${NINJA_EXECUTABLE} -C <BINARY_DIR> install
)

# xkbcommon - xkbcommon-1.8.0
# Packages needed: libxcb-xkb-dev
ExternalProject_Add(libxkbcommon
  SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/libxkbcommon"
  INSTALL_DIR ${CMAKE_INSTALL_PREFIX}
  CONFIGURE_COMMAND ${MESON_EXECUTABLE} --prefix=<INSTALL_DIR> <BINARY_DIR> <SOURCE_DIR> -Denable-bash-completion=false
  BUILD_COMMAND ${NINJA_EXECUTABLE} -C <BINARY_DIR>
  INSTALL_COMMAND ${NINJA_EXECUTABLE} -C <BINARY_DIR> install
)

# wayland-protocols - 1.47
ExternalProject_Add(wayland-protocols
  SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/wayland-protocols"
  INSTALL_DIR ${CMAKE_INSTALL_PREFIX}
  CONFIGURE_COMMAND ${MESON_EXECUTABLE} --prefix=<INSTALL_DIR> <BINARY_DIR> <SOURCE_DIR>
  BUILD_COMMAND ${NINJA_EXECUTABLE} -C <BINARY_DIR>
  INSTALL_COMMAND ${NINJA_EXECUTABLE} -C <BINARY_DIR> install
)

# pixman - pixman-0.46.0
ExternalProject_Add(pixman
  SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/pixman"
  INSTALL_DIR ${CMAKE_INSTALL_PREFIX}
  CONFIGURE_COMMAND ${MESON_EXECUTABLE} --prefix=<INSTALL_DIR> <BINARY_DIR> <SOURCE_DIR>
  BUILD_COMMAND ${NINJA_EXECUTABLE} -C <BINARY_DIR>
  INSTALL_COMMAND ${NINJA_EXECUTABLE} -C <BINARY_DIR> install
)

# XWayland as optional dependency, configure wlroots accordingly.
PKG_CHECK_MODULES(XWAYLAND xwayland>=22.1.9)
IF(XWAYLAND_FOUND)
  SET(WLROOTS_XWAYLAND "-Dxwayland=enabled")
ELSE(XWAYLAND_FOUND)
  SET(WLROOTS_XWAYLAND  "-Dxwayland=disabled")
ENDIF(XWAYLAND_FOUND)

ExternalProject_Add(wlroots
  SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/wlroots"
  INSTALL_DIR ${CMAKE_INSTALL_PREFIX}
  CONFIGURE_COMMAND ${MESON_EXECUTABLE} --prefix=<INSTALL_DIR> <BINARY_DIR> <SOURCE_DIR> -Dexamples=true -Dbackends=drm,libinput,x11 ${WLROOTS_XWAYLAND}
  BUILD_COMMAND ${NINJA_EXECUTABLE} -C <BINARY_DIR>
  INSTALL_COMMAND ${NINJA_EXECUTABLE} -C <BINARY_DIR> install
)

=== share/CMakeLists.txt ===
# Copyright 2024 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/wlmaker.desktop.in
  ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.desktop
  @ONLY)
# Install to both wayland-sessions/ and applications/ -- it can run in windowed
# mode.
INSTALL(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.desktop
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
INSTALL(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.desktop
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/wayland-sessions)

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/wlmaker.wlmclock.desktop.in
  ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.wlmclock.desktop
  @ONLY)
INSTALL(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.wlmclock.desktop
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/wlmaker.wlmcpugraph.desktop.in
  ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.wlmcpugraph.desktop
  @ONLY)
INSTALL(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.wlmcpugraph.desktop
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/wlmaker.wlmnetgraph.desktop.in
  ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.wlmnetgraph.desktop
  @ONLY)
INSTALL(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.wlmnetgraph.desktop
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/wlmaker.wlmmemgraph.desktop.in
  ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.wlmmemgraph.desktop
  @ONLY)
INSTALL(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.wlmmemgraph.desktop
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/wlmaker.wlmeyes.desktop.in
  ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.wlmeyes.desktop
  @ONLY)
INSTALL(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/wlmaker.wlmeyes.desktop
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

FIND_PROGRAM(DESKTOP_FILE_VALIDATOR NAMES desktop-file-validate OPTIONAL)
IF(DESKTOP_FILE_VALIDATOR)
  ADD_TEST(
    NAME wlmaker_desktop_test
    COMMAND ${DESKTOP_FILE_VALIDATOR} "${CMAKE_CURRENT_BINARY_DIR}/wlmaker.desktop")
  # We also want to report errors that are not "fatal" yet.
  SET_PROPERTY(
    TEST wlmaker_desktop_test
    PROPERTY FAIL_REGULAR_EXPRESSION " error: ")
  ADD_TEST(
    NAME wlmclock_desktop_test
    COMMAND ${DESKTOP_FILE_VALIDATOR} "${CMAKE_CURRENT_BINARY_DIR}/wlmaker.wlmclock.desktop")
  # We also want to report errors that are not "fatal" yet.
  SET_PROPERTY(
    TEST wlmclock_desktop_test
    PROPERTY FAIL_REGULAR_EXPRESSION " error: ")
  ADD_TEST(
    NAME wlmcpugraph_desktop_test
    COMMAND ${DESKTOP_FILE_VALIDATOR} "${CMAKE_CURRENT_BINARY_DIR}/wlmaker.wlmcpugraph.desktop")
  # We also want to report errors that are not "fatal" yet.
  SET_PROPERTY(
    TEST wlmcpugraph_desktop_test
    PROPERTY FAIL_REGULAR_EXPRESSION " error: ")
  ADD_TEST(
    NAME wlmnetgraph_desktop_test
    COMMAND ${DESKTOP_FILE_VALIDATOR} "${CMAKE_CURRENT_BINARY_DIR}/wlmaker.wlmnetgraph.desktop")
  # We also want to report errors that are not "fatal" yet.
  SET_PROPERTY(
    TEST wlmnetgraph_desktop_test
    PROPERTY FAIL_REGULAR_EXPRESSION " error: ")
  ADD_TEST(
    NAME wlmmemgraph_desktop_test
    COMMAND ${DESKTOP_FILE_VALIDATOR} "${CMAKE_CURRENT_BINARY_DIR}/wlmaker.wlmmemgraph.desktop")
  # We also want to report errors that are not "fatal" yet.
  SET_PROPERTY(
    TEST wlmmemgraph_desktop_test
    PROPERTY FAIL_REGULAR_EXPRESSION " error: ")
  ADD_TEST(
    NAME wlmeyes_desktop_test
    COMMAND ${DESKTOP_FILE_VALIDATOR} "${CMAKE_CURRENT_BINARY_DIR}/wlmaker.wlmeyes.desktop")
  # We also want to report errors that are not "fatal" yet.
  SET_PROPERTY(
    TEST wlmeyes_desktop_test
    PROPERTY FAIL_REGULAR_EXPRESSION " error: ")
ELSE()
  MESSAGE(STATUS "Skipping .desktop file validation -- `desktop-file-validate` not found")
ENDIF()

INSTALL(FILES
  wlmaker.svg
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps)
INSTALL(FILES
  wlmaker-48x48.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps
  RENAME wlmaker.png)
INSTALL(FILES
  wlmaker-64x64.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps
  RENAME wlmaker.png)

INSTALL(FILES
  wlmclock-64x64.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps
  RENAME wlmclock.png)
INSTALL(FILES
  wlmcpugraph-64x64.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps
  RENAME wlmcpugraph.png)
INSTALL(FILES
  wlmmemgraph-64x64.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps
  RENAME wlmmemgraph.png)
INSTALL(FILES
  wlmnetgraph-64x64.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps
  RENAME wlmnetgraph.png)

INSTALL(FILES
  wlmeyes-64x64.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps
  RENAME wlmeyes.png)

INSTALL(FILES
  wlmaker/icons/chrome-48x48.png
  wlmaker/icons/clip-48x48.png
  wlmaker/icons/firefox-48x48.png
  wlmaker/icons/terminal-48x48.png
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/wlmaker/icons)

=== src/CMakeLists.txt ===
# Copyright 2023 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)

# Further dependency versions, as submodules:
# * drm at libdrm-2.4.117
# * hwdata at v0.371
# * libdisplay-info at 0.2.0
# * pixman at pixman-0.43.0

PKG_CHECK_MODULES(WAYLAND_SERVER REQUIRED IMPORTED_TARGET wayland-server>=1.22.0)
# We build for wlroots 0.18, 0.19 and (preparing for) 0.20.
PKG_CHECK_MODULES(WLROOTS IMPORTED_TARGET wlroots-0.20>=0.20)
IF(NOT WLROOTS_FOUND)
  PKG_CHECK_MODULES(WLROOTS IMPORTED_TARGET wlroots-0.19>=0.19)
  IF(NOT WLROOTS_FOUND)
    PKG_CHECK_MODULES(WLROOTS REQUIRED IMPORTED_TARGET wlroots-0.18>=0.18)
  ENDIF(NOT WLROOTS_FOUND)
ENDIF(NOT WLROOTS_FOUND)
PKG_CHECK_MODULES(XCB REQUIRED IMPORTED_TARGET xcb>=1.15)
# XWayland considered optional.
PKG_CHECK_MODULES(XWAYLAND xwayland>=22.1.9)

ADD_SUBDIRECTORY(backend)
ADD_SUBDIRECTORY(toolkit)

SET(PUBLIC_HEADER_FILES
  action.h
  action_item.h
  background.h
  backtrace.h
  clip.h
  config.h
  corner.h
  cursor.h
  dock.h
  files.h
  icon_manager.h
  idle.h
  input_observation.h
  keyboard.h
  launcher.h
  layer_panel.h
  layer_shell.h
  lock_mgr.h
  root_menu.h
  server.h
  subprocess_monitor.h
  task_list.h
  tl_menu.h
  xdg_decoration.h
  xdg_popup.h
  xdg_shell.h
  xdg_toplevel.h
  xwl.h
  xwl_surface.h)

ADD_LIBRARY(wlmaker_lib STATIC)
TARGET_SOURCES(wlmaker_lib PRIVATE
  action.c
  action_item.c
  background.c
  backtrace.c
  clip.c
  config.c
  corner.c
  cursor.c
  dock.c
  files.c
  icon_manager.c
  idle.c
  input_observation.c
  keyboard.c
  launcher.c
  layer_panel.c
  layer_shell.c
  lock_mgr.c
  root_menu.c
  server.c
  subprocess_monitor.c
  task_list.c
  tl_menu.c
  x11_cursor.xpm
  xdg_decoration.c
  xdg_popup.c
  xdg_shell.c
  xdg_toplevel.c
  xwl.c
  xwl_surface.c
)
SET_TARGET_PROPERTIES(
  wlmaker_lib PROPERTIES
  VERSION 1.0
  PUBLIC_HEADER "${PUBLIC_HEADER_FILES}")
IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    wlmaker_lib PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

ADD_DEPENDENCIES(
  wlmaker_lib
  backend
  embedded_configuration
  embedded_root_menu
  embedded_state
  embedded_theme
  libbase
  libbase_plist
  protocol_headers
  toolkit
  wlmaker_lib)

TARGET_LINK_LIBRARIES(
  wlmaker_lib
  backend
  embedded_configuration
  embedded_root_menu
  embedded_state
  embedded_theme
  inih
  libbase
  libbase_plist
  toolkit
  wlmaker_protocols
  $<$<BOOL:${LIBBACKTRACE}>:${LIBBACKTRACE}>
  PkgConfig::CAIRO
  PkgConfig::LIBXDGBASEDIR
  PkgConfig::WAYLAND_SERVER
  PkgConfig::WLROOTS
  PkgConfig::XCB
  PkgConfig::XKBCOMMON)
TARGET_INCLUDE_DIRECTORIES(
  wlmaker_lib PUBLIC
  # Keep wlroots first -- multiple versions may interfere (#117).
  ${WLROOTS_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_BINARY_DIR}/third_party/protocols
  ${PROJECT_BINARY_DIR}/protocols
  ${CAIRO_INCLUDE_DIRS}
  ${LIBXDGBASEDIR_INCLUDE_DIRS}
  ${WAYLAND_SERVER_INCLUDE_DIRS}
  ${XCB_INCLUDE_DIRS}
  ${XKBCOMMON_INCLUDE_DIRS}
)
TARGET_COMPILE_DEFINITIONS(
  wlmaker_lib PRIVATE WLMAKER_SOURCE_DIR="${PROJECT_SOURCE_DIR}")
TARGET_COMPILE_DEFINITIONS(
  wlmaker_lib PRIVATE WLMAKER_BINARY_DIR="${PROJECT_BINARY_DIR}")
IF(wmmenugen_executable)
  TARGET_COMPILE_DEFINITIONS(
    wlmaker_lib PRIVATE WLMAKER_WMMENUGEN_PATH="${wmmenugen_executable}")
ENDIF(wmmenugen_executable)
IF(XWAYLAND_FOUND)
  TARGET_COMPILE_DEFINITIONS(wlmaker_lib PUBLIC WLMAKER_HAVE_XWAYLAND)
ENDIF(XWAYLAND_FOUND)
IF(LIBBACKTRACE)
  TARGET_COMPILE_DEFINITIONS(wlmaker_lib PRIVATE WLMAKER_HAVE_LIBBACKTRACE)
ENDIF()

ADD_EXECUTABLE(wlmaker wlmaker.c)
ADD_DEPENDENCIES(wlmaker wlmaker_lib)
TARGET_COMPILE_OPTIONS(
  wlmaker PRIVATE
  ${WAYLAND_SERVER_CFLAGS}
  ${WAYLAND_SERVER_CFLAGS_OTHER})
TARGEt_COMPILE_DEFINITIONS(
  wlmaker PRIVATE
  WLMAKER_VERSION_MAJOR="${WLMAKER_VERSION_MAJOR}"
  WLMAKER_VERSION_MINOR="${WLMAKER_VERSION_MINOR}"
  WLMAKER_VERSION_FULL="${WLMAKER_VERSION_FULL}")
TARGET_LINK_LIBRARIES(wlmaker PRIVATE libbase libbase_plist wlmaker_lib)
IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    wlmaker PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

INSTALL(TARGETS wlmaker DESTINATION ${CMAKE_INSTALL_BINDIR})

=== tool/CMakeLists.txt ===
# Copyright 2025 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)

ADD_EXECUTABLE(wlmtool wlmtool.c gen_menu.c)
TARGET_LINK_LIBRARIES(
  wlmtool
  libbase
  libbase_plist
  desktop-parser
  PkgConfig::LIBXDGBASEDIR)
TARGET_INCLUDE_DIRECTORIES(
  wlmtool
  PRIVATE
  ${LIBXDGBASEDIR_INCLUDE_DIRS})
TARGET_COMPILE_DEFINITIONS(
  wlmtool PRIVATE
  WLMAKER_VERSION_MAJOR="${WLMAKER_VERSION_MAJOR}"
  WLMAKER_VERSION_MINOR="${WLMAKER_VERSION_MINOR}"
  WLMAKER_VERSION_FULL="${WLMAKER_VERSION_FULL}")

INSTALL(
  TARGETS wlmtool
  DESTINATION ${CMAKE_INSTALL_BINDIR})

IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    wlmtool PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

ADD_SUBDIRECTORY(desktop-parser)

=== tool/desktop-parser/CMakeLists.txt ===
# Copyright 2025 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

CMAKE_MINIMUM_REQUIRED(VERSION 3.13)

ADD_LIBRARY(desktop-parser STATIC desktop-parser.c)
TARGET_LINK_LIBRARIES(desktop-parser PRIVATE libbase inih)
TARGET_INCLUDE_DIRECTORIES(
  desktop-parser
  PUBLIC
  ${CMAKE_CURRENT_SOURCE_DIR}/..)
SET_TARGET_PROPERTIES(
  desktop-parser PROPERTIES
  VERSION 1.0
  PUBLIC_HEADER desktop-parser.h)

IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    desktop-parser PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

=== submodules/libbase/src/CMakeLists.txt ===
# Copyright 2025 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

SET(PUBLIC_HEADER_FILES
  arg.h
  assert.h
  atomic.h
  avltree.h
  def.h
  dequeue.h
  dllist.h
  dynbuf.h
  file.h
  gfxbuf.h
  gfxbuf_xpm.h
  libbase.h
  log.h
  log_wrappers.h
  ptr_set.h
  ptr_stack.h
  ptr_vector.h
  sock.h
  strutil.h
  subprocess.h
  test.h
  thread.h
  time.h
  vector.h)

SET(SOURCES
  arg.c
  atomic.c
  avltree.c
  dequeue.c
  dllist.c
  dynbuf.c
  file.c
  gfxbuf.c
  gfxbuf_xpm.c
  log.c
  ptr_set.c
  ptr_stack.c
  ptr_vector.c
  sock.c
  strutil.c
  subprocess.c
  test.c
  thread.c
  time.c)

ADD_LIBRARY(libbase STATIC)
TARGET_SOURCES(libbase PRIVATE ${SOURCES})
TARGET_INCLUDE_DIRECTORIES(
  libbase
  PUBLIC
  $<INSTALL_INTERFACE:include>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)
TARGET_INCLUDE_DIRECTORIES(libbase PRIVATE ${CURSES_INCLUDE_DIRS})
TARGET_LINK_LIBRARIES(libbase PRIVATE ${CURSES_LIBRARIES})
SET_TARGET_PROPERTIES(
  libbase PROPERTIES
  VERSION 1.0
  PUBLIC_HEADER "${PUBLIC_HEADER_FILES}"
)

IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    libbase PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

IF(CAIRO_FOUND)
  TARGET_COMPILE_DEFINITIONS(libbase PUBLIC HAVE_CAIRO)
  TARGET_INCLUDE_DIRECTORIES(libbase PUBLIC ${CAIRO_INCLUDE_DIRS})
  TARGET_LINK_LIBRARIES(libbase PUBLIC PkgConfig::CAIRO)
ENDIF(CAIRO_FOUND)

# Add 'install' target, but only if we're the toplevel project.
IF(CMAKE_PROJECT_NAME STREQUAL libbase)
  INSTALL(
    TARGETS libbase
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libbase")
ENDIF()

=== submodules/libbase/src/plist/CMakeLists.txt ===
# Copyright 2024 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

FIND_PACKAGE(FLEX 2.6 REQUIRED)
FLEX_TARGET(
  analyzer
  analyzer.l
  ${CMAKE_CURRENT_BINARY_DIR}/analyzer.c
  DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/analyzer.h)

FIND_PACKAGE(BISON 3.0 REQUIRED)
BISON_TARGET(
  grammar
  grammar.y
  ${CMAKE_CURRENT_BINARY_DIR}/grammar.c
  DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/grammar.h)

ADD_FLEX_BISON_DEPENDENCY(analyzer grammar)

SET(PUBLIC_HEADER_FILES
  ${PROJECT_SOURCE_DIR}/include/libbase/plist/decode.h
  ${PROJECT_SOURCE_DIR}/include/libbase/plist/model.h
  ${PROJECT_SOURCE_DIR}/include/libbase/plist/parse.h)

ADD_LIBRARY(libbase_plist STATIC)
TARGET_SOURCES(libbase_plist PRIVATE
  decode.c
  model.c
  parse.c
  ${CMAKE_CURRENT_BINARY_DIR}/analyzer.c
  ${CMAKE_CURRENT_BINARY_DIR}/grammar.c)
TARGET_INCLUDE_DIRECTORIES(
  libbase_plist
  PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}/)

# TODO(kaeser@gubbe.ch):Remove, once updating post bison 3.8.2 (Aug 2022).
# See: https://github.com/phkaeser/wlmaker/issues/53
TARGET_COMPILE_OPTIONS(libbase_plist PRIVATE -Wno-unused-but-set-variable)
TARGET_LINK_LIBRARIES(libbase_plist libbase)
SET_TARGET_PROPERTIES(
  libbase_plist
  PROPERTIES VERSION 1.0
  PUBLIC_HEADER "${PUBLIC_HEADER_FILES}")
IF(iwyu_path_and_options)
  SET_TARGET_PROPERTIES(
    libbase_plist PROPERTIES
    C_INCLUDE_WHAT_YOU_USE "${iwyu_path_and_options}")
ENDIF(iwyu_path_and_options)

# Add 'install' target, but only if `libbase` is the toplevel project.
IF(CMAKE_PROJECT_NAME STREQUAL libbase)
  INSTALL(
    TARGETS libbase_plist
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libbase/plist")
ENDIF()

=== debian/changelog ===
wlmaker (0.7.1-2) experimental; urgency=medium

  * d/control: update build-depends libwlroots-dev to 0.20.

 -- Alex Myczko <tar@debian.org>  Sat, 14 Feb 2026 16:10:06 +0000

wlmaker (0.7.1-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Sat, 14 Feb 2026 16:04:08 +0000

=== debian/control ===
Source: wlmaker
Section: gnustep
Priority: optional
Maintainer: Debian GNUstep maintainers <pkg-gnustep-maintainers@lists.alioth.debian.org>
Uploaders: Alex Myczko <tar@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 bison,
 cmake,
 flex,
 libwayland-dev,
 libcairo2-dev,
 wayland-protocols,
 libwlroots-0.20-dev,
 libncurses-dev,
# plantuml,
 libwayland-bin,
 libxdg-basedir-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/phkaeser/wlmaker
Vcs-Browser: https://salsa.debian.org/gnustep-team/wlmaker
Vcs-Git: https://salsa.debian.org/gnustep-team/wlmaker.git

Package: wlmaker
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 foot,
 swaylock,
 wdisplays,
Description: Wayland compositor inspired by Window Maker
 This is a Wayland compositor inspired by Window Maker.
  - Compositor for windows in stacking mode.
  - Supports multiple workspaces.
  - Appearance inspired by Window Maker, following the look and feel of
    NeXTSTEP.
  - Easy to use, lightweight, low gimmicks and fast.
  - Dock and clip, to be extended for dockable apps.
